<?php
namespace plugins\smsbao;

use app\common\controller\Plugins;
use think\facade\Cache;

class Plugin extends Plugins
{
    /**
     * 安装前的业务处理，可在此方法实现，默认返回true
     */
    public function install()
    {
        return true;
    }

    /**
     * 卸载前的业务处理，可在此方法实现，默认返回true
     */
    public function uninstall()
    {
        return true;
    }

    public function enable()
    {
        return true;
    }

    public function disable()
    {
        return true;
    }
    public function sms($param=[])
    {
        $smsConfig = $this->getConfig();
        if($smsConfig['base']['enable']=='N')
        {
            return json_encode(['code'=>0,'msg'=>'短信功能未启用'], JSON_UNESCAPED_UNICODE);
        }

        //短信宝短信
        if($smsConfig['base']['enable']=='smsbao')
        {
            $sms_user = $smsConfig['smsbao']['sms_user'];
            $sms_pwd = md5($smsConfig['smsbao']['sms_pwd']);
            // 签名
            $smsSign = $smsConfig['smsbao']['SignName'];
            // 模板
            $template = $smsConfig['smsbao']['TemplateCode'];
            $statusStr = array(
                "0" => "短信发送成功",
                "-1" => "参数不全",
                "-2" => "服务器空间不支持,请确认支持curl或者fsocket，联系您的空间商解决或者更换空间！",
                "30" => "密码错误",
                "40" => "账号不存在",
                "41" => "余额不足",
                "42" => "帐户已过期",
                "43" => "IP地址限制",
                "50" => "内容含有敏感词"
            );
            try {
                /* 模板参数: 若无模板参数，则设置为空*/
                $code = rand(100000,999999);
                $cache_code = Cache::get('sms_'.$param['mobile']);
                // 通过 client 对象调用 SendSms 方法发起请求。注意请求方法名与请求对象是对应的
                if(!$cache_code) {
                    //发送短信
                    $smsapi = "http://api.smsbao.com/";
                    $content='【'.$smsSign.'】'.str_replace('{$code}',$code,$template);//要发送的短信内容
                    $phone = $param['mobile'];//要发送短信的手机号码
                    $sendurl = $smsapi."sms?u=".$sms_user."&p=".$sms_pwd."&m=".$phone."&c=".urlencode($content);
                    $result =file_get_contents($sendurl) ;
                    if ($result == '0') {
                        Cache::set('sms_'.$param['mobile'],$code,60*5);
                        return json_encode(['code' => 1, 'msg' => '短信发送成功'], JSON_UNESCAPED_UNICODE);
                    } else {
                        return json_encode(['code' => 0, 'msg' => $statusStr[$result]], JSON_UNESCAPED_UNICODE);
                    }
                }
                return json_encode(['code'=>0,'msg'=>'验证码5分钟内有效，请使用收到验证码进行填写'],JSON_UNESCAPED_UNICODE);
            }
            catch(\Exception $e) {
                return json_encode(['code'=>0,'msg'=>$e->getMessage()], JSON_UNESCAPED_UNICODE);
            }
        }
        return false;
    }
}